# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`ora_asm_directory`](#ora_asm_directory): This type allows you to manage your ASM Directories.  Like the other Oracle types, it's not mandatory to specify a SID here. In that case it 
* [`ora_asm_diskgroup`](#ora_asm_diskgroup): This type allows you to manage your ASM diskgroups.  Like the other Oracle types, you must specify the SID. But for this type it must be the 
* [`ora_asm_volume`](#ora_asm_volume): This type allows you to manage ASM volumes.  Here is an example on defining an ACFS volume:      ora_asm_volume{diskgroup:my_volume@+ASM1":  
* [`ora_audit_policy`](#ora_audit_policy): This resource allows you to manage the Unified Audit policies. This Puppet type supports managing the next policy types:  - privileges - role
* [`ora_autotask`](#ora_autotask): This resource allows you to manage auto tasks in the (pluggable) database  It allows you to enable/disable individual tasks (sql_tuning_advis
* [`ora_awr_settings`](#ora_awr_settings): This resource allows you to manage AWR settings in an Oracle database.   This type allows you to set retention, interval and topnsql       or
* [`ora_database`](#ora_database): This resource allows you to manage an Oracle Database.  This type allows you to create a database. In one of it's simplest form:      ora_dat
* [`ora_directory`](#ora_directory): This resource allows you to manage directory mappings from inside an Oracle database to a directory outside of the database. Here is an examp
* [`ora_exec`](#ora_exec): This type allows you run a specific SQL statement or an sql file on a specified instance sid.      ora_exec{"drop table application_users@sid
* [`ora_feature_usage`](#ora_feature_usage): This resource allows you to report on Database feature usage      ora_feature_usage { '<feature>@<database>':       max_usage => 200,       w
* [`ora_function`](#ora_function): This resource allows you to manage PL/SQL functions in the Oracle database.      ora_function { 'testuser.return_some_value':       ensure  =
* [`ora_home_option`](#ora_home_option): This resource allows you to manage(enable/disable) options in an Oracle database home.      ora_home_option { '/u01/app/oracle/product/12.1.0
* [`ora_init_param`](#ora_init_param): This resource allows you to manage Oracle parameters.  this type allows you to manage your init.ora parameters. You can manage your `spfile` 
* [`ora_listener`](#ora_listener): This manages the oracle listener process.  It makes sure the Oracle SQL*Net listener is running.      ora_listener {'SID':       ensure  => '
* [`ora_object_audit`](#ora_object_audit): This type allows you to enable or disable auditing inside an Oracle Database.  Here is an example to set auditing on the `SYS.AUD$` table:   
* [`ora_object_grant`](#ora_object_grant): This type allows you to grant users rights to specified database objects.  To grant user `SCOTT` `execute` and `debug` rights on on the `sys.
* [`ora_package`](#ora_package): This resource allows you to manage PL/SQL packages in the Oracle database.      ora_package { 'testuser.pkg_manage_my_objects':       ensure 
* [`ora_procedure`](#ora_procedure): This resource allows you to manage PL/SQL procedures in the Oracle database.      ora_procedure { 'testuser.proc_manage_my_objects':       en
* [`ora_profile`](#ora_profile): This resource allows you to manage a user profile in an Oracle database.  Here is an example on how to use this:      ora_profile { 'DEFAULT@
* [`ora_record`](#ora_record): This resource allows you to manage a record in an Oracle database table.  Use ora_record to make sure a record with a specified primary key e
* [`ora_role`](#ora_role): This type allows you to create or delete a role inside an Oracle Database.  It recognises a limit part of the options that [CREATE ROLE](http
* [`ora_scheduler_job`](#ora_scheduler_job): This resource allows you to manage schedulaed jobs in the Oracle database. Here is an example on how to use this:      ora_scheduler_job{'sys
* [`ora_schema_definition`](#ora_schema_definition): This resource allows you to manage a schema definition. This includes all tables, indexes and other DDL that is needed for your application. 
* [`ora_service`](#ora_service): This resource allows you to manage a service in an Oracle database.  It has support for serices on single instance databases, but also suppor
* [`ora_setting`](#ora_setting): This resource allows you to set the defaults for all other ora types.   All ora types need a `ora_setting` definition. This is a pointer to a
* [`ora_statement_audit`](#ora_statement_audit): This type allows you to enable or disable auditing inside an Oracle Database.
* [`ora_synonym`](#ora_synonym): This resource allows you to manage a synonym an Oracle database. You can create both public synonyms or private synonyms. To create a public 
* [`ora_tablespace`](#ora_tablespace): This type allows you to manage an Oracle tablespace. The datafile and num_datafiles properties are mutually exclusive. When specifying multip
* [`ora_thread`](#ora_thread): This resource allows you to manage threads in an Oracle database.   This type allows you to enable a thread. Threads are used in Oracle RAC i
* [`ora_trigger`](#ora_trigger): This resource allows you to manage PL/SQL packages in the Oracle database.      ora_trigger { 'testuser.my_trigger':       ensure  => 'presen
* [`ora_user`](#ora_user): This type allows you to manage a user inside an Oracle database.  It recognises most of the options that [CREATE USER](http://docs.oracle.com

### Functions

* [`ora_config::available_sids`](#ora_configavailable_sids): See the file "LICENSE" for the full license governing this code.  This function will return an array of all sids registered in the ora_settin
* [`ora_config::generated_password`](#ora_configgenerated_password): See the file "LICENSE" for the full license governing this code.
* [`ora_config::is_cluster`](#ora_configis_cluster): See the file "LICENSE" for the full license governing this code.   Function to fetch the fact ora_is_cluster and based on that information de
* [`ora_config::is_container_db`](#ora_configis_container_db): See the file "LICENSE" for the full license governing this code.   Function to fetch the fact ora_is_container_db and based on that informati
* [`ora_config::is_pluggable_db`](#ora_configis_pluggable_db): See the file "LICENSE" for the full license governing this code.   Function to fetch the fact ora_is_pluggable_db and based on that informati
* [`ora_config::is_primary_db`](#ora_configis_primary_db): See the file "LICENSE" for the full license governing this code.   Function to fetch the fact ora_is_primary_db and based on that information
* [`ora_config::is_root_db`](#ora_configis_root_db): See the file "LICENSE" for the full license governing this code.   Function to fetch the fact ora_is_root_db and based on that information de
* [`ora_config::is_seed_db`](#ora_configis_seed_db): See the file "LICENSE" for the full license governing this code.   Function to fetch the fact ora_is_seed_db and based on that information de
* [`ora_config::on_sid`](#ora_configon_sid): See the file "LICENSE" for the full license governing this code.

### Tasks

* [`extract`](#extract): Extracts the current config from a source database in hiera settings
* [`extract_data_bu`](#extract_data_bu): Extracts the data from a database using rman backup
* [`extract_data_dp`](#extract_data_dp): Extracts the data from a database using datapump
* [`insert_data_bu`](#insert_data_bu): Restores a database from an rman backup
* [`insert_data_dp`](#insert_data_dp): Inserts the data from a database using datapump
* [`profile`](#profile): Allows get the status, create or remove an Oracle profile
* [`role`](#role): Allows get the status, create or remove an Oracle role
* [`service`](#service): Allows get the status, create or remove an Oracle service
* [`sql`](#sql): Allows you to execute arbitraryarbitary SQL and return the output as raw text or an array of values
* [`tablespace`](#tablespace): Allows get the status, create or remove an Oracle tablespace
* [`user`](#user): Allows get the status, create or remove an Oracle user

### Plans

* [`ora_config::extract`](#ora_configextract): See the file "LICENSE" for the full license governing this code.  ++--++ --++--
* [`ora_config::extract_as_node`](#ora_configextract_as_node): See the file "LICENSE" for the full license governing this code.  ++--++ --++--

## Resource types

### <a name="ora_asm_directory"></a>`ora_asm_directory`

This type allows you to manage your ASM Directories.

Like the other Oracle types, it's not mandatory to specify a SID here.
In that case it will use the ora_setting entry for ASM with the `default` property set to `true`
If you do specify a SID it must be an ASM sid.
Most of the times, this is `+ASM`

    ora_asm_directory {'+DATA/DIR/SUBDIR@+ASM':
      ensure          => 'present',
      path            => '+DATA/DIR/SUBDIR'
    }

#### Properties

The following properties are available in the `ora_asm_directory` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_asm_directory` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_asm_directory` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_asm_diskgroup"></a>`ora_asm_diskgroup`

This type allows you to manage your ASM diskgroups.

Like the other Oracle types, you must specify the SID. But for this type it must be the ASM sid.
Most of the times, this is `+ASM1`

    ora_asm_diskgroup {'REDO@+ASM1':
      ensure          => 'present',
      redundancy_type => 'normal',
      compat_asm      => '11.2.0.0.0',
      compat_rdbms    => '11.2.0.0.0',
      disks           => {
        'FAILGROUP1' => [
          { 'diskname' => 'REDOVOL1', 'path' => 'ORCL:REDOVOL1'}
        ],
        'FAILGROUP2' => [
          { 'diskname' => 'REDOVOL2', 'path' => 'ORCL:REDOVOL2'},
        ]
      }
    }

#### Properties

The following properties are available in the `ora_asm_diskgroup` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_asm_diskgroup` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_asm_diskgroup` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_asm_volume"></a>`ora_asm_volume`

This type allows you to manage ASM volumes.

Here is an example on defining an ACFS volume:

    ora_asm_volume{diskgroup:my_volume@+ASM1":
      size          => '10G',
    }

Before you can issue this definition, the diskgroup must already exists.

#### Properties

The following properties are available in the `ora_asm_volume` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_asm_volume` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_asm_volume` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_audit_policy"></a>`ora_audit_policy`

This resource allows you to manage the Unified Audit policies. This
Puppet type supports managing the next policy types:

- privileges
- roles
- actions (Anly standard actions)
- object (only partly)

Here is an example on how to use this:

    ora_audit_policy { 'ORA_DATABASE_PARAMETER@TEST':
      ensure   => 'present',
      actions  => ['ALTER DATABASE', 'ALTER SYSTEM', 'CREATE SPFILE'],
    }

#### Properties

The following properties are available in the `ora_audit_policy` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_audit_policy` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_audit_policy` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_autotask"></a>`ora_autotask`

This resource allows you to manage auto tasks in the (pluggable) database

It allows you to enable/disable individual tasks (sql_tuning_advisor, auto_optimizer_stats_collection, auto_space_advisor)
or enable/disable all the auto tasks (auto_task)

ora_autotask { 'DBNAME':
  auto_optimizer_stats_collection => 'enabled',
  auto_space_advisor              => 'enabled',
  auto_task                       => 'enabled',
  sql_tuning_advisor              => 'enabled',
}

#### Parameters

The following parameters are available in the `ora_autotask` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_autotask` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_awr_settings"></a>`ora_awr_settings`

This resource allows you to manage AWR settings in an Oracle database.


This type allows you to set retention, interval and topnsql


    ora_awr_settings { 'DBNAME':
      retention     => 60,
      snap_interval => 8,
      topnsql       => 'DEFAULT',
    }

This will set the default AWR settings for database 'DBNAME'

#### Parameters

The following parameters are available in the `ora_awr_settings` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_awr_settings` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_database"></a>`ora_database`

This resource allows you to manage an Oracle Database.

This type allows you to create a database. In one of it's simplest form:

    ora_database{'oradb':
      ensure          => present,
      oracle_base     => '/opt/oracle',
      oracle_home     => '/opt/oracle/app/11.04',
      control_file    => 'reuse',
    }

The `ora_database` type uses structured types for some of the parameters. Here is part of an example
with some of these structured parameters filled in:

    ora_database{'bert':
      logfile_groups => [
          {file_name => 'test1.log', size => '10M'},
          {file_name => 'test2.log', size => '10M'},
        ],
      ...
      default_tablespace => {
        name      => 'USERS',
        datafile  => {
          file_name  => 'users.dbs',
          size       => '1G',
          reuse      =>  true,
        },
        extent_management => {
          type          => 'local',
          autoallocate  => true,
        }
      },
      ...
      datafiles       => [
        {file_name   => 'file1.dbs', size => '1G', reuse => true},
        {file_name   => 'file2.dbs', size => '1G', reuse => true},
      ],
      ...
      default_temporary_tablespace => {
        name      => 'TEMP',
        type      => 'bigfile',
        tempfile  => {
          file_name  => 'tmp.dbs',
          size       => '1G',
          reuse      =>  true,
          autoextend => {
            next    => '10K',
            maxsize => 'unlimited',
          }
        },
        extent_management => {
          type          => 'local',
          uniform_size  => '1G',
        },
      },
      ....
      undo_tablespace   => {
        name      => 'UNDOTBS',
        type      => 'bigfile',
        datafile  => {
          file_name  => 'undo.dbs',
          size       => '1G',
          reuse      =>  true,
        }
      },
      ....
      sysaux_datafiles => [
        {file_name   => 'sysaux1.dbs', size => '1G', reuse => true},
        {file_name   => 'sysaux2.dbs', size => '1G', reuse => true},
      ]

#### Properties

The following properties are available in the `ora_database` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_database` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_database` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_directory"></a>`ora_directory`

This resource allows you to manage directory mappings from inside an Oracle database to
a directory outside of the database. Here is an example:

    ora_directory { 'ORACLE_OCM_CONFIG_DIR2@test':
      ensure         => 'present',
      directory_path => '/opt/oracle/app/11.04/ccr/state',
    }

#### Properties

The following properties are available in the `ora_directory` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_directory` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_directory` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_exec"></a>`ora_exec`

This type allows you run a specific SQL statement or an sql file on a specified instance sid.

    ora_exec{"drop table application_users@sid":
      username => 'app_user',
      password => 'password,'
    }

This statement will execute the sql statement `drop table application_users` on the instance names `instance`.

You can use the `unless` parameter to only execute the statement in certain states. If the query specified in the
`unless` parameter returns one or more records, the main statement is skipped.

    ora_exec{ "create synonym ${user}.${synonym} for USER.${synonym}":
      unless  => "select * from all_synonyms where owner=\'${user}\' and synonym_name=\'${synonym}\'",
    }

You can also execute a script.

    ora_exec{"@/tmp/do_some_stuff.sql@sid":
      username  => 'app_user',
      password  => 'password,'
      logoutput => on_failure,  # can be true, false or on_failure
    }

This statement will run the sqlscript `/tmp/do_some_stuff.sql` on the sid named `sid`. Use the `unless`
parameter to just execute the script in certain situations.

When you don't specify the username and the password, the type will connect as `sysdba`.

#### Parameters

The following parameters are available in the `ora_exec` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_exec` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="ora_feature_usage"></a>`ora_feature_usage`

This resource allows you to report on Database feature usage

    ora_feature_usage { '<feature>@<database>':
      max_usage => 200,
      when_used => 'warning|error',
    }

Managable features are:

    - 'active_data_guard'
    - 'advanced_analytics'
    - 'advanced_compression'
    - 'advanced_security'
    - 'change_management_pack'
    - 'configuration_management_pack_for_oracle_database'
    - 'data_masking_pack'
    - 'database_gateway'
    - 'database_in-memory'
    - 'database_vault'
    - 'diagnostics_pack'
    - 'exadata'
    - 'goldengate'
    - 'hw'
    - 'label_security'
    - 'multitenant'
    - 'olap'
    - 'partitioning'
    - 'pillar_storage'
    - 'provisioning_and_patch_automation_pack'
    - 'provisioning_and_patch_automation_pack_for_database'
    - 'rac_or_rac_one_node'
    - 'real_application_clusters'
    - 'real_application_clusters_one_node'
    - 'real_application_testing'
    - 'secure_backup'
    - 'spatial_and_graph'
    - 'tuning_pack'
    - 'webLogic_server_management_pack_enterprise_edition'

#### Parameters

The following parameters are available in the `ora_feature_usage` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_feature_usage` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_function"></a>`ora_function`

This resource allows you to manage PL/SQL functions in the Oracle database.

    ora_function { 'testuser.return_some_value':
      ensure  => 'present',
      source => '/vagrant/tests/function.sql',
    }

This puppet definition ensures that the function `testuser.return_some_value` is available
in the database and that its content matches the content defined in the specified source.

To decide if the function needs an update, the puppet type compares the content in the database, with
the content in the source file. This comparison is done insenitive to case, white spacing and used quote's
(the " or the ` ).

When you have specified `report_errors => true` (which is the default), the type will fail on PL/SQL
compilation errors. functions with compilation errors do however end up in the database. On a second Puppet
run the won't be updated. Puppet reports a warning these resources though?

```
Warning: function TESTUSER.RETURN_SOME_VALUE@test up-to-date, but contains 4 error(s).
```

#### Properties

The following properties are available in the `ora_function` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_function` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_function` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_home_option"></a>`ora_home_option`

This resource allows you to manage(enable/disable) options in an Oracle database home.

    ora_home_option { '/u01/app/oracle/product/12.1.0/db_home1':
      datamining               => 'disabled',
      direct_nfs               => 'disabled',
      olap                     => 'disabled',
      partitioning             => 'disabled',
      real_application_testing => 'disabled',
    }

#### Parameters

The following parameters are available in the `ora_home_option` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_home_option` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_init_param"></a>`ora_init_param`

This resource allows you to manage Oracle parameters.

this type allows you to manage your init.ora parameters. You can manage your `spfile` parameters and your `memory`
parameters. First the easy variant where you want to change an spfile parameter on your current sid for your current sid.

    ora_init_param{'SPFILE/PARAMETER':
      ensure  => present,
      value   => 'the_value'
    }

To manage the same parameter only the in-memory one, use:

    init_param{'MEMORY/PARAMETER':
      ensure  => present,
      value   => 'the_value'
    }

If you are running RAC and need to specify a parameter for an other instance, you can specify the instance as well.

    init_param{'MEMORY/PARAMETER:INSTANCE':
      ensure  => present,
      value   => 'the_value'
    }

Having more then one sid running on your node and you want to specify the sid you want to use, use `@SID` at the end.

    init_param{'MEMORY/PARAMETER:INSTANCE@SID':
      ensure  => present,
      value   => 'the_value'
    }

Managing parameters of pluggable database is also supported. This behaves
like regular databases.

    init_param{'MEMORY/PARAMETER:INSTANCE@SID':
      ensure  => present,
      value   => 'the_value'
    }

#### Properties

The following properties are available in the `ora_init_param` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_init_param` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_init_param` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_listener"></a>`ora_listener`

This manages the oracle listener process.

It makes sure the Oracle SQL*Net listener is running.

    ora_listener {'SID':
      ensure  => 'running',
      require => Exec['db_install_instance'],
    }

The name of the resource *MUST* be the sid for which you want to start the listener,
unless instance_name is specified.

#### Properties

The following properties are available in the `ora_listener` type.

##### `ensure`

Valid values: `stopped`, `running`, ``false``, ``true``

Aliases: `"false"=>"stopped", "true"=>"running"`

Whether a listener should be running.

This is a required property without any defaults.

#### Parameters

The following parameters are available in the `ora_listener` type.

* [`instance_name`](#instance_name)
* [`name`](#name)
* [`provider`](#provider)

##### <a name="instance_name"></a>`instance_name`

The database instance name.

The instance_name parameter *MUST* be the sid for which you want to start the listener.

##### <a name="name"></a>`name`

namevar

The sid of the listener to run.

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_listener` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_object_audit"></a>`ora_object_audit`

This type allows you to enable or disable auditing inside an Oracle Database.

Here is an example to set auditing on the `SYS.AUD$` table:

    ora_object_audit { 'SYS.AUD$@test':
      ensure            => 'present',
      alter_failure     => 'by_access',
      alter_success     => 'by_access',
      audit_failure     => 'by_access',
      audit_success     => 'by_access',
      comment_failure   => 'by_access',
      comment_success   => 'by_access',
      flashback_failure => 'by_access',
      flashback_success => 'by_access',
      grant_failure     => 'by_access',
      grant_success     => 'by_access',
      index_failure     => 'by_access',
      index_success     => 'by_access',
      insert_failure    => 'by_access',
      insert_success    => 'by_access',
      lock_failure      => 'by_access',
      lock_success      => 'by_access',
      rename_failure    => 'by_access',
      rename_success    => 'by_access',
      select_failure    => 'by_access',
      select_success    => 'by_access',
      update_failure    => 'by_access',
      update_success    => 'by_access',
    }

Some audit options only apply to some types of database records. Specify only
those options that apply to the object you want to audit.

#### Properties

The following properties are available in the `ora_object_audit` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_object_audit` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_object_audit` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_object_grant"></a>`ora_object_grant`

This type allows you to grant users rights to specified database objects.

To grant user `SCOTT` `execute` and `debug` rights on on the `sys.dbms_aqin` packgage, you can use:

    ora_object_grant{'SCOTT->sys.dbms_aqin@SID':
      permissions => ['execute', 'debug'],
    }

If you want to make sure the user only has `execute` rights, use:

    ora_object_grant{'OTHER_USER->sys.dbms_aqin@SID':
       permissions => ['execute'],
    }

If you want to make sure **no** permissions are granted, you can use an empty array like this:

    ora_object_grant{'OTHER_USER->sys.dbms_aqin':
       permissions => [],
    }

#### Parameters

The following parameters are available in the `ora_object_grant` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_object_grant` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_package"></a>`ora_package`

This resource allows you to manage PL/SQL packages in the Oracle database.

    ora_package { 'testuser.pkg_manage_my_objects':
      ensure  => 'present',
      source => '/vagrant/tests/package.sql',
    }

This puppet definition ensures that the package `testuser.pkg_manage_my_objects` is available
in the database and that its content matches the content defined in the specified source.

To decide if the package needs an update, the puppet type compares the content in the database, with
the content in the source file. This comparison is done insenitive to case, white spacing and used quote's
(the " or the ` ).

When you have specified `report_errors => true` (which is the default), the type will fail on PL/SQL
compilation errors. Packages with compilation errors do however end up in the database. On a second Puppet
run the won't be updated. Puppet reports a warning these resources though?

```
Warning: package TESTUSER.PKG_MANAGE_MY_OBJECTS@test up-to-date, but contains 4 error(s).
```

#### Properties

The following properties are available in the `ora_package` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_package` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_package` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_procedure"></a>`ora_procedure`

This resource allows you to manage PL/SQL procedures in the Oracle database.

    ora_procedure { 'testuser.proc_manage_my_objects':
      ensure  => 'present',
      source => '/vagrant/tests/procedure.sql',
    }

This puppet definition ensures that the procedure `testuser.proc_manage_my_objects` is available
in the database and that its content matches the content defined in the specified source.

To decide if the procedure needs an update, the puppet type compares the content in the database, with
the content in the source file. This comparison is done insenitive to case, white spacing and used quote's
(the " or the ` ).

When you have specified `report_errors => true` (which is the default), the type will fail on PL/SQL
compilation errors. procedures with compilation errors do however end up in the database. On a second Puppet
run the won't be updated. Puppet reports a warning these resources though?

```
Warning: procedure TESTUSER.PROC_MANAGE_MY_OBJECTS@test up-to-date, but contains 4 error(s).
```

#### Properties

The following properties are available in the `ora_procedure` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_procedure` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_procedure` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_profile"></a>`ora_profile`

This resource allows you to manage a user profile in an Oracle database.

Here is an example on how to use this:

    ora_profile { 'DEFAULT@sid':
      ensure                    => 'present',
      composite_limit           => 'UNLIMITED',
      connect_time              => 'UNLIMITED',
      cpu_per_call              => 'UNLIMITED',
      cpu_per_session           => 'UNLIMITED',
      failed_login_attempts     => '10',
      idle_time                 => 'UNLIMITED',
      logical_reads_per_call    => 'UNLIMITED',
      logical_reads_per_session => 'UNLIMITED',
      password_grace_time       => '7',
      password_life_time        => '180',
      password_lock_time        => '1',
      password_reuse_max        => 'UNLIMITED',
      password_reuse_time       => 'UNLIMITED',
      password_verify_function  => 'NULL',
      private_sga               => 'UNLIMITED',
      sessions_per_user         => 'UNLIMITED',
      inactive_account_time     => '120',
      container                 => 'ALL'
    }

#### Parameters

The following parameters are available in the `ora_profile` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_profile` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_record"></a>`ora_record`

This resource allows you to manage a record in an Oracle database table.

Use ora_record to make sure a record with a specified primary key exists in the specified table. Here is
an exaple:

    ora_record{'set_external_service_name':
      ensure     => 'present',
      table_name => 'CONFIG_DATA',
      key_name   => 'CONFIG_ID',
      key_value  => 10,
      username   => 'ORACLE_USER',
      password   => 'verysecret',
      data       => {
        'CONFIG_NAME'  => 'service_name',
        'CONFIG_VALUE' => 'http://external.data-server.com',
        ...
      }
    }

This Puppet code tells you that the table CONFIG_DATA from user ORACLE_USER must contain a record where
the primary key CONFIG_ID is 10. If Puppet notices that this record doesn't exist, It will create the
record and fill its data with the data specified in the data property. If Puppet sees that the key already
exists, it does nothing. This code will make sure your database contains the record, but it will not
ALWAYS set the data. This code is useful for example in use cases where there is a set of management
screens to manage these settings. Puppet makes sure the setting exists, but will leave the settings
as they are after the system is running and applications managers might have changed the values.


If you **always** want to make sure the record contains the specified data, use `updated` for the `ensure`
property.

    ora_record{'set_external_service_name':
      ensure     => 'updated',
      table_name => 'CONFIG_DATA',
      username   => 'ORACLE_USER',
      password   => 'verysecret',
      key_name   => 'CONFIG_ID',
      key_value  => 10,
      data       => {
        'CONFIG_NAME'  => 'service_name',
        'CONFIG_VALUE' => 'http://external.data-server.com',
        ...
      }
    }

Now Puppet will not only check if the record exists, but it will also always make sure the specified columns
contain the specified values. If there are columns you don't want to manage, then just leave them blank.

#### Parameters

The following parameters are available in the `ora_record` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_record` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="ora_role"></a>`ora_role`

This type allows you to create or delete a role inside an Oracle Database.

It recognises a limit part of the options that [CREATE ROLE](http://docs.oracle.com/cd/B28359_01/server.111/b28286/statements_6012.htm#SQLRF01311) supports.

    ora_role {'just_a_role@sid':
      ensure    => present,
    }

You can also add grants to a role:

    ora_role {'just_a_role@sid':
      ensure    => present,
      grants    => ['create session','create table'],
    }

#### Properties

The following properties are available in the `ora_role` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_role` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_role` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="ora_scheduler_job"></a>`ora_scheduler_job`

This resource allows you to manage schedulaed jobs in the Oracle database. Here is
an example on how to use this:

    ora_scheduler_job{'sys.cleanup_audit_job@SID':
      ensure          => 'present',
      job_type        => 'PLSQL_BLOCK',
      job_action      => 'begin cleanup_audit; end;',
      start_date      => '18-10-2018 23:45:00',
      repeat_interval => 'FREQ=DAILY',
      comments        => 'Purge Audit Logs',
      enabled         => 'TRUE',
    }

#### Properties

The following properties are available in the `ora_scheduler_job` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_scheduler_job` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_scheduler_job` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_schema_definition"></a>`ora_schema_definition`

This resource allows you to manage a schema definition. This includes all tables, indexes and other DDL that is needed for your application.

    ora_schema_definition{'MYAPP':
        ensure      => '1.0.0',
        schema_name => 'MYAPP,
        password    => 'verysecret',
        source_path => '/opt/stage/myapp/sql',
    }

In this example we tell Puppet, we need schema version `1.0.0` for `MYAPP` in the database. In layman's terms
now the following things will happen:

- The Puppet type will log in to the database using username `myapp` and the very secret password and it will look at the version of the schema already available.
- If the current version is lower than the specified version, Puppet will execute the upgrade SQL scripts in the source path until the correct version is reached.
- If the current version is higher than the requested version, Puppet will execute the downgrade scripts until the requested version is reached.

## Schema version?

What is this concept of a schema version? To administer the current version, Puppet uses a table called `SCHEMA_VERSION`.
Here is the definition of this table:

    CREATE TABLE schema_version
    (  id                NUMBER
      ,application       VARCHAR2(255)
      ,version           VARCHAR2(255)
      ,description       VARCHAR2(255)
      ,installation_time TIMESTAMP(6)
    );

Puppet uses this table to store the history of all schema versions applied. If the table doesn't exists, Puppet will
create it for you. Using this information, Puppet can tell what the state of the current schema in the database is.
Puppet creates this table for every single schema/user you manage. This means, you can have multiple schemas with
different versions in your database.

## What about these upgrade and downgrade scripts.

In order for Puppet to do it's magic, the upgrade and downgrade scripts, need to have specific names.
Here is a listing of some upgrade scripts:

    upgrades/0000_myapp_0.0.1_initial-schema.sql
    upgrades/0001_myapp_0.0.2_add-user-table.sql
    upgrades/0002_myapp_0.1.0_initial-release.sql

As you can see, all the file names have the following structure:

- a four-digit sequence number
- application name
- version number
- description

All fields are separated by an underscore. The upgrade scripts contain all SQL statements needed to upgrade
the database schema to the desired state. In general upgrade scripts contain statements to create tables and
indexes and add or remove columns, but you can also insert data into the lookup-tables or create database packages.

The `downgrades` directory contains scripts with the same names. The downgrade scripts contain the SQL statements
needed to put the database in the state it was before. So if you add a column in an upgrade script, you'll have
to remove this column in the downgrade script.

#### Parameters

The following parameters are available in the `ora_schema_definition` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_schema_definition` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="ora_service"></a>`ora_service`

This resource allows you to manage a service in an Oracle database.

It has support for serices on single instance databases, but also supports
creating services on a RAC cluster.  Here is an example on setting a service
on a RAC cluster.

    ora_service { 'MYSERVICE.DEVELOPMENT.ORG@SID1':
      ensure              => 'present',
      aq_ha_notifications => 'false',
      clb_goal            => 'LONG',
      dtp                 => 'false',
      failover_delay      => '0',
      failover_method     => 'NONE',
      failover_retries    => '0',
      failover_type       => 'NONE',
      lb_advisory         => 'THROUGHPUT',
      management_policy   => 'AUTOMATIC',
      preferred_instances => ['O2DEVEL1'],
      server_pool         => ['O2DEVEL_STAM.DEVELOPMENT.ORG'],
      service_role        => 'PRIMARY',
      status              => 'running',
      taf_policy          => 'NONE',
    }

On a single instance Oracle database, most of the above options are ignored. So a simple version
of the manifest for such a database would be:

    ora_service { 'MYSERVICE.DEVELOPMENT.ORG@SID1':
      ensure              => 'present',
    }

`ora_service` doesn't manage the internal services created by Oracle.

#### Properties

The following properties are available in the `ora_service` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_service` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_service` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_setting"></a>`ora_setting`

This resource allows you to set the defaults for all other ora types.


All ora types need a `ora_setting` definition. This is a pointer to a local or remote database.
You need to create one for every local, remote or pluggable database you want to manage.
When you don't provide a `ora_setting` identifier in the title of the oracle type then it will use `default` as identifier.
The connect string is according to the EZCONNECT naming method.

Here is an example on how to create the `default` settings:

    ora_setting { '<SID>':
      default        => true|false,
      user           => '<username>',
      password       => '<password>',
      syspriv        => 'sysdba|sysasm|sysoper|sysbackup|sysdg|syskm',
      oracle_home    => '<path>',
      connect_string => "[//]host[:port][/service_name][:server][/instance]",
      pluggable      => true|false,
    }

If you want to manage a remote database, like for instance `DB1`. You will have to specify a local oracle_home from where sqlplus can be started.
You use `ora_setting` like this:

    ora_setting { 'DB1':
      default        => true,
      user           => 'sys',
      password       => 'password',
      syspriv        => 'sysdba',
      oracle_home    => '/opt/oracle/12.1.0.2/db',
      connect_string => '//host1:1522/DB1',
      pluggable      => false,
    }

#### Parameters

The following parameters are available in the `ora_setting` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_setting` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_statement_audit"></a>`ora_statement_audit`

This type allows you to enable or disable auditing inside an Oracle Database.

#### Properties

The following properties are available in the `ora_statement_audit` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_statement_audit` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_statement_audit` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="ora_synonym"></a>`ora_synonym`

This resource allows you to manage a synonym an Oracle database. You can create both
public synonyms or private synonyms. To create a public synonym use:

    ora_synonym { 'PUBLIC.SYNONYM_NAME@SID':
      ensure      => 'present',
      table_name  => 'TABLE_NAME',
      table_owner => 'TABLE_OWNER',
    }

To create a private synonym, you'll have to specfy the owner in the title:

    ora_synonym { 'OWNER.SYNONYM_NAME@SID':
      ensure      => 'present',
      table_name  => 'TABLE_NAME',
      table_owner => 'TABLE_OWNER',
    }

#### Properties

The following properties are available in the `ora_synonym` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_synonym` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_synonym` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_tablespace"></a>`ora_tablespace`

This type allows you to manage an Oracle tablespace.
The datafile and num_datafiles properties are mutually exclusive.
When specifying multiple datafiles(or num_datfiles > 1) all datafiles will get the same settings for size, autoextend, next and max_size.

It recognises most of the options that [CREATE TABLESPACE](http://docs.oracle.com/cd/B28359_01/server.111/b28310/tspaces002.htm#ADMIN11359) supports.

    ora_tablespace {'my_app_ts@sid':
      ensure                    => present,
      datafile                  => 'my_app_ts.dbf',
      size                      => 5G,
      logging                   => yes,
      autoextend                => on,
      next                      => 100M,
      max_size                  => 20G,
      extent_management         => local,
      segment_space_management  => auto,
      encryption                => 'AES256',
    }

Tablespace with multiple datafiles:

    ora_tablespace {'my_app_ts@sid':
      ensure                    => present,
      datafile                  => ['my_app_ts01.dbf', 'my_app_ts02.dbf'],
      size                      => 5G,
      logging                   => yes,
      autoextend                => on,
      next                      => 100M,
      max_size                  => 20G,
      extent_management         => local,
      segment_space_management  => auto,
      encryption                => 'AES256',
    }

Tablespace with multiple datafiles using Oracle Managed Files:

    ora_tablespace {'my_app_ts@sid':
      ensure                    => present,
      num_datafile              => 3,
      size                      => 5G,
      logging                   => yes,
      autoextend                => on,
      next                      => 100M,
      max_size                  => 20G,
      extent_management         => local,
      segment_space_management  => auto,
      encryption                => 'AES256',
    }

You can also create an undo tablespace:

    ora_tablespace {'my_undots_1@sid':
      ensure                    => present,
      contents                  => 'undo',
    }

or a temporary tablespace:

    tablespace {'my_temp_ts@sid':
      ensure                    => present,
      datafile                  => 'my_temp_ts.dbf',
      contents                  => 'temporary',
      size                      => 5G,
      autoextend                => on,
      next                      => 100M,
      max_size                  => 20G,
      extent_management         => local,
      segment_space_management  => auto,
    }

#### Properties

The following properties are available in the `ora_tablespace` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_tablespace` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_tablespace` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_thread"></a>`ora_thread`

This resource allows you to manage threads in an Oracle database.


This type allows you to enable a thread. Threads are used in Oracle RAC installations. This type is not very useful
for regular use, but it is used in the [Oracle RAC module](https://forge.puppetlabs.com/hajee/ora_rac).


    ora_thread{"2@sid":
      ensure  => 'enabled',
    }

This enables thread 2 on instance named `sid`

#### Parameters

The following parameters are available in the `ora_thread` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_thread` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="ora_trigger"></a>`ora_trigger`

This resource allows you to manage PL/SQL packages in the Oracle database.

    ora_trigger { 'testuser.my_trigger':
      ensure  => 'present',
      source => '/vagrant/tests/triger.sql',
    }

This puppet definition ensures that the trigger `testuser.my_trigger` is available
in the database and that its content matches the content defined in the specified source.

To decide if the package needs an update, the puppet type compares the content in the database, with
the content in the source file. This comparison is done insenitive to case, white spacing and used quote's
(the " or the ` ).

When you have specified `report_errors => true` (which is the default), the type will fail on PL/SQL
compilation errors. Packages with compilation errors do however end up in the database. On a second Puppet
run the won't be updated. Puppet reports a warning these resources though?

```
Warning: trigger TESTUSER.MY_TRIGGER@test up-to-date, but contains 4 error(s).
```

#### Properties

The following properties are available in the `ora_trigger` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_trigger` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_trigger` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_user"></a>`ora_user`

This type allows you to manage a user inside an Oracle database.

It recognises most of the options that [CREATE USER](http://docs.oracle.com/cd/B28359_01/server.111/b28286/statements_8003.htm#SQLRF01503) supports. Besides these options, you can also use this type to manage the grants and the quota's for this user.

    ora_user{user_name@sid:
      temporary_tablespace      => temp,
      default_tablespace        => 'my_app_ts',
      password                  => 'verysecret',
      require                   => Ora_tablespace['my_app_ts'],
      grants                    => ['SELECT ANY TABLE', 'CONNECT', 'CREATE TABLE', 'CREATE TRIGGER'],
      quotas                    => {
                                      "my_app_ts"  => 'unlimited'
                                    },
    }

#### Parameters

The following parameters are available in the `ora_user` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_user` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

## Functions

### <a name="ora_configavailable_sids"></a>`ora_config::available_sids`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.

This function will return an array of all sids registered in the ora_settings
file

#### `ora_config::available_sids()`

See the file "LICENSE" for the full license governing this code.

This function will return an array of all sids registered in the ora_settings
file

Returns: `Array`

### <a name="ora_configgenerated_password"></a>`ora_config::generated_password`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.

#### `ora_config::generated_password(Optional[Integer] $password_length)`

See the file "LICENSE" for the full license governing this code.

Returns: `String`

##### `password_length`

Data type: `Optional[Integer]`



### <a name="ora_configis_cluster"></a>`ora_config::is_cluster`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_cluster and based on that information
decide if the specified sid is a cluster e.g. RAC database or not.

#### `ora_config::is_cluster(String $sid)`

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_cluster and based on that information
decide if the specified sid is a cluster e.g. RAC database or not.

Returns: `Any`

##### `sid`

Data type: `String`



### <a name="ora_configis_container_db"></a>`ora_config::is_container_db`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_container_db and based on that information
decide if the specified sid is a container database or not.

#### `ora_config::is_container_db(String $sid)`

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_container_db and based on that information
decide if the specified sid is a container database or not.

Returns: `Any`

##### `sid`

Data type: `String`



### <a name="ora_configis_pluggable_db"></a>`ora_config::is_pluggable_db`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_pluggable_db and based on that information
decide if the specified sid is a pluggable database or not.

#### `ora_config::is_pluggable_db(String $sid)`

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_pluggable_db and based on that information
decide if the specified sid is a pluggable database or not.

Returns: `Any`

##### `sid`

Data type: `String`



### <a name="ora_configis_primary_db"></a>`ora_config::is_primary_db`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_primary_db and based on that information
decide if the specified sid is a container database or not.

#### `ora_config::is_primary_db(String $sid)`

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_primary_db and based on that information
decide if the specified sid is a container database or not.

Returns: `Any`

##### `sid`

Data type: `String`



### <a name="ora_configis_root_db"></a>`ora_config::is_root_db`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_root_db and based on that information
decide if the specified sid is a root database or not.

#### `ora_config::is_root_db(String $sid)`

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_root_db and based on that information
decide if the specified sid is a root database or not.

Returns: `Any`

##### `sid`

Data type: `String`



### <a name="ora_configis_seed_db"></a>`ora_config::is_seed_db`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_seed_db and based on that information
decide if the specified sid is a seed database or not.

#### `ora_config::is_seed_db(String $sid)`

See the file "LICENSE" for the full license governing this code.


Function to fetch the fact ora_is_seed_db and based on that information
decide if the specified sid is a seed database or not.

Returns: `Any`

##### `sid`

Data type: `String`



### <a name="ora_configon_sid"></a>`ora_config::on_sid`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.

#### `ora_config::on_sid(Variant[Array, Undef] $values, String $select_sid)`

See the file "LICENSE" for the full license governing this code.

Returns: `Any`

##### `values`

Data type: `Variant[Array, Undef]`



##### `select_sid`

Data type: `String`



## Tasks

### <a name="extract"></a>`extract`

Extracts the current config from a source database in hiera settings

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1]`

The SID of the database.

##### `oracle_home`

Data type: `String[1]`

The Oracle home this database is runing from.

##### `os_user`

Data type: `String[1]`

The os user Oracle is running under.

##### `cdb`

Data type: `Boolean`

Is the database a container database.

##### `pluggable`

Data type: `Boolean`

Is the database a pluggable database.

##### `contained_by`

Data type: `String`

If it is a pluggable the name of the container

##### `system_password`

Data type: `Optional[String]`

The SYSTEM password to be used for the exported database

##### `sys_password`

Data type: `Optional[String]`

The SYS password to be used for the exported database

##### `os_user_password`

Data type: `Optional[String]`

The OS password for the OS user (e.g. Oracle) to be used on the exported database

### <a name="extract_data_bu"></a>`extract_data_bu`

Extracts the data from a database using rman backup

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1]`

The SID of the database.

##### `oracle_home`

Data type: `String[1]`

The Oracle home this database is runing from.

##### `os_user`

Data type: `String[1]`

The os user Oracle is running under.

##### `directory`

Data type: `String[1]`

The directory where the backup should be written to

### <a name="extract_data_dp"></a>`extract_data_dp`

Extracts the data from a database using datapump

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1]`

The SID of the database.

##### `oracle_home`

Data type: `String[1]`

The Oracle home this database is runing from.

##### `cdb`

Data type: `Boolean`

Is the database a container database. *** NOT IMPLEMENTED YET ***

##### `pluggable`

Data type: `Boolean`

Is the database a pluggable database. *** NOT IMPLEMENTED YET ***

##### `contained_by`

Data type: `String`

If it is a pluggable the name of the container. *** NOT IMPLEMENTED YET ***

##### `database_user`

Data type: `String`

The database user used for the datapump export

##### `database_user_password`

Data type: `String`

The password of the 'database_user'

##### `os_user`

Data type: `String[1]`

The OS user used for the datapump export

##### `directory`

Data type: `String[1]`

The directory where the export file should be written to

##### `schemas`

Data type: `Array`

Array of schemas to be exported

### <a name="insert_data_bu"></a>`insert_data_bu`

Restores a database from an rman backup

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1]`

The SID of the database.

##### `oracle_home`

Data type: `String[1]`

The Oracle home this database is runing from.

##### `oracle_base`

Data type: `String[1]`

The Oracle base for this database.

##### `os_user`

Data type: `String[1]`

The os user Oracle is running under.

##### `os_group`

Data type: `String[1]`

The os group Oracle is running under.

##### `directory`

Data type: `String[1]`

The directory where the backup file should be read from

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="insert_data_dp"></a>`insert_data_dp`

Inserts the data from a database using datapump

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1]`

The SID of the database.

##### `oracle_home`

Data type: `String[1]`

The Oracle home this database is runing from.

##### `cdb`

Data type: `Boolean`

Is the database a container database. *** NOT IMPLEMENTED YET ***

##### `pluggable`

Data type: `Boolean`

Is the database a pluggable database. *** NOT IMPLEMENTED YET ***

##### `contained_by`

Data type: `String`

If it is a pluggable the name of the container. *** NOT IMPLEMENTED YET ***

##### `database_user`

Data type: `String`

The database user used for the datapump export

##### `database_user_password`

Data type: `String`

The password of the 'database_user'

##### `os_user`

Data type: `String[1]`

The OS user used for the datapump export

##### `directory`

Data type: `String[1]`

The directory where the import file is located

### <a name="profile"></a>`profile`

Allows get the status, create or remove an Oracle profile

**Supports noop?** false

#### Parameters

##### `action`

Data type: `Optional[Enum['list', 'status','create','remove']]`

The action you want to execute

##### `profile_name`

Data type: `Optional[String[1]]`

The name of the Oracle profile to use.

##### `properties`

Data type: `Optional[Hash]`

The properties to use when create a Oracle profile

### <a name="role"></a>`role`

Allows get the status, create or remove an Oracle role

**Supports noop?** false

#### Parameters

##### `action`

Data type: `Optional[Enum['list', 'status','create','remove']]`

The action you want to execute

##### `role_name`

Data type: `Optional[String[1]]`

The name of the Oracle role to use.

##### `properties`

Data type: `Optional[Hash]`

The properties to use when create a Oracle role

### <a name="service"></a>`service`

Allows get the status, create or remove an Oracle service

**Supports noop?** false

#### Parameters

##### `action`

Data type: `Optional[Enum['list', 'status','create','remove']]`

The action you want to execute

##### `service_name`

Data type: `Optional[String[1]]`

The name of the Oracle service to use.

##### `properties`

Data type: `Optional[Hash]`

The properties to use when create a Oracle service

### <a name="sql"></a>`sql`

Allows you to execute arbitraryarbitary SQL and return the output as raw text or an array of values

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `Optional[String[1]]`

SID of the database to connect to

##### `username`

Data type: `Optional[String[1]]`

The Oracle username to use. When none is specfied, SYS will be used.

##### `password`

Data type: `Optional[String[1]]`

The password to use. Only valid when specifying an Oracle username

##### `sql`

Data type: `String[1]`

The SQL you want to execute

##### `raw`

Data type: `Optional[Boolean]`

When true, it returns the output as a raw string. When false, it returns the value as an array of values. Default valu is true

### <a name="tablespace"></a>`tablespace`

Allows get the status, create or remove an Oracle tablespace

**Supports noop?** false

#### Parameters

##### `action`

Data type: `Optional[Enum['list', 'status','create','remove']]`

The action you want to execute

##### `tablespace_name`

Data type: `Optional[String[1]]`

The name of the Oracle tablespace to use.

##### `properties`

Data type: `Optional[Hash]`

The properties to use when create a Oracle tablespace

### <a name="user"></a>`user`

Allows get the status, create or remove an Oracle user

**Supports noop?** false

#### Parameters

##### `action`

Data type: `Optional[Enum['list', 'status','create','remove']]`

The action you want to execute

##### `user_name`

Data type: `Optional[String[1]]`

The name of the Oracle user to use.

##### `properties`

Data type: `Optional[Hash]`

The properties to use when create a Oracle user

## Plans

### <a name="ora_configextract"></a>`ora_config::extract`

See the file "LICENSE" for the full license governing this code.

++--++
--++--

#### Parameters

The following parameters are available in the `ora_config::extract` plan:

* [`target`](#target)
* [`sid`](#sid)
* [`oracle_home`](#oracle_home)
* [`output_file`](#output_file)
* [`os_user`](#os_user)
* [`cdb`](#cdb)
* [`pluggable`](#pluggable)
* [`contained_by`](#contained_by)

##### <a name="target"></a>`target`

Data type: `TargetSpec`



##### <a name="sid"></a>`sid`

Data type: `String[1]`



##### <a name="oracle_home"></a>`oracle_home`

Data type: `String[1]`



##### <a name="output_file"></a>`output_file`

Data type: `String[1]`



##### <a name="os_user"></a>`os_user`

Data type: `String[1]`



Default value: `'oracle'`

##### <a name="cdb"></a>`cdb`

Data type: `Boolean`



Default value: ``false``

##### <a name="pluggable"></a>`pluggable`

Data type: `Boolean`



Default value: ``false``

##### <a name="contained_by"></a>`contained_by`

Data type: `String`



Default value: `''`

### <a name="ora_configextract_as_node"></a>`ora_config::extract_as_node`

See the file "LICENSE" for the full license governing this code.

++--++
--++--

#### Parameters

The following parameters are available in the `ora_config::extract_as_node` plan:

* [`target`](#target)
* [`sid`](#sid)
* [`oracle_home`](#oracle_home)
* [`output_file`](#output_file)
* [`system_password`](#system_password)
* [`sys_password`](#sys_password)
* [`os_user_password`](#os_user_password)
* [`role`](#role)
* [`patch_level`](#patch_level)
* [`version`](#version)
* [`database_type`](#database_type)
* [`os_user`](#os_user)
* [`cdb`](#cdb)
* [`pluggable`](#pluggable)
* [`contained_by`](#contained_by)

##### <a name="target"></a>`target`

Data type: `TargetSpec`



##### <a name="sid"></a>`sid`

Data type: `String[1]`



##### <a name="oracle_home"></a>`oracle_home`

Data type: `String[1]`



##### <a name="output_file"></a>`output_file`

Data type: `String[1]`



##### <a name="system_password"></a>`system_password`

Data type: `Sensitive`



##### <a name="sys_password"></a>`sys_password`

Data type: `Sensitive`



##### <a name="os_user_password"></a>`os_user_password`

Data type: `Sensitive`



##### <a name="role"></a>`role`

Data type: `String[1]`



Default value: `'ora_profile::extracted_database'`

##### <a name="patch_level"></a>`patch_level`

Data type: `String[1]`



Default value: `'NONE'`

##### <a name="version"></a>`version`

Data type: `String[1]`



Default value: `'19.0.0.0'`

##### <a name="database_type"></a>`database_type`

Data type: `String[1]`



Default value: `'EE'`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`



Default value: `'oracle'`

##### <a name="cdb"></a>`cdb`

Data type: `Boolean`



Default value: ``false``

##### <a name="pluggable"></a>`pluggable`

Data type: `Boolean`



Default value: ``false``

##### <a name="contained_by"></a>`contained_by`

Data type: `String`



Default value: `''`

