# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../../../../easy_type/lib"))
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../.."))

require 'facter'
require 'puppet'
# rubocop:disable Lint/SuppressedException
begin
  require 'puppet/type/ora_asm_diskgroup'
  require 'puppet/type/ora_asm_volume'
rescue StandardError
end
# rubocop:enable Lint/SuppressedException

Facter.add('ora_asm_running') do
  confine :kernel => 'Linux'
  setcode do
    `ps -ef | egrep "asm_pmon_.+$" | grep -v grep` != ''
  end
end

Facter.add('ora_asm_diskgroups') do
  confine :ora_asm_running => true

  setcode do
    Puppet_X::EnterpriseModules::Oracle::Resources::OraAsmDiskgroup.index
  end
end

Facter.add('ora_asm_volumes') do
  confine :ora_asm_running => true

  setcode do
    Puppet_X::EnterpriseModules::Oracle::Resources::OraAsmVolume.index
  end
end
