# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This function will return an array of all sids registered in the ora_settings
# file
Puppet::Functions.create_function('ora_config::available_sids') do
  dispatch :available_sids do
    return_type 'Array'
  end

  def available_sids
    require_relative '../../../puppet_x/enterprisemodules/oracle/utilities'
    extend Puppet_X::EnterpriseModules::Oracle::Settings
    database_sids
  end
end
