#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newparam(:volume_device) do
  include EasyType

  desc <<-DESC
    The device the volume is created on.

    This required parameter must be a valid empry folder, the volume will be mounted on.

        ora_asm_volume { ...:
          ...
          volume_device => '/mnt/oravolume',
        }

  DESC

  # TODO: Find out why this doesn't work
  # data_type("Stdlib::Absolutepath")
  data_type('String[1]')

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('VOLUME_DEVICE')
  end
end
