# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:policy_name) do
  include EasyType
  include EasyType::Validators::Name
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase

  desc 'The policy name'

  isnamevar

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('POLICY_NAME').upcase
  end

  data_type('String[1]')
end
