# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:snap_interval) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access

  desc <<-DESC
    The snap_interval in minutes.
  DESC

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('SNAP_INTERVAL')
  end

  data_type('Optional[Integer]')

  on_modify do
    statement = "exec dbms_workload_repository.modify_snapshot_settings(interval => #{value})"
    sql(statement, :sid => local_sid_for_db(resource.name))
    nil
  end
end
