#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'puppet_x/enterprisemodules/oracle/schemas'
require 'puppet_x/enterprisemodules/extend_hash'

newparam(:extent_management) do
  # docs
  class ::Puppet::Type::Ora_database::ParameterExtent_management
    include EasyType
    include Puppet_X::EnterpriseModules::Oracle::Schemas

    newvalues(:local)

    data_type("Optional[Enum['local']]")

    desc <<-DESC
    Specify the extent management.

    Use this syntax to specify all attributes:

        ora_database{'dbname':
          ...
          extent_management => 'local'
        }

    DESC
  end
end
