#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newproperty(:national_character_set, :parent => ::Puppet_X::EnterpriseModules::Oracle::ReadOnlyProperty) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access
  include Puppet_X::EnterpriseModules::Oracle::Information

  to_translate_to_resource do |raw_resource|
    database_properties(raw_resource['SID']).find { |e| e['PROPERTY_NAME'] == 'NLS_NCHAR_CHARACTERSET' }['VALUE'] if raw_resource['STATE'] == 'running'
  end

  desc <<-DESC
    The national character set used to store data in columns.
  DESC

  on_apply do
    "NATIONAL CHARACTER SET #{value}"
  end

  data_type('Optional[String[1]]')
end
