#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newparam(:options, :array_matching => :all) do
  include EasyType

  desc <<-DESC
    Specify the options that need to be enabled in the database.

        ora_database{'dbname':
          ...
          options => [
              'OWM',
              'JServer',
              'CTX',
              'ORD',
              'IM',
              'OLAP',
              'SDO',        # Requires XDB(default), JServer and ORD
              'OLS',
              'Sample',     # Requires installation of Oracle Database Examples
              'APEX',
              'DV'
            ],
        }

  DESC

  defaultto []
  data_type('Optional[Array[String[1]]]')
end
