# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:pdb_admin_password) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Utilities

  defaultto generated_password(12)

  desc <<-DESC
    Specify the password for the admin user of the pluggable database.
    This parameter is mandatory when creating a pluggable databases.

    ora_database { 'my_database':
      ensure             => present,
      ...
      pdb_admin_password => 'password',
      ...
    }
  DESC

  on_apply do
    "identified by #{value}"
  end

  data_type('String')
end
