#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newparam(:spfile_location) do
  include EasyType

  desc <<-DESC
    Location of the database's spfile. If you specify this paramater, a spfile will be
    created at the specified location. If you don't specify this parameter **no** spfile
    will be created.

    You can use this parameter like this:

        ora_database{'db1':
          ...
          spfile_location => '/opt/oracle/...../dbs/',
        }

    or

        ora_database{'db1':
          ...
          spfile_location => '+RECODG',
        }
  DESC

  data_type('Optional[String[1]]')
end
