#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newparam(:sys_password) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Utilities

  defaultto generated_password(12)

  desc <<-DESC
    The password of the SYS account.
    This parameter is mandatory when creating a (container) database.
  DESC

  on_apply do
    "user sys identified by #{value}"
  end

  data_type('String')
end
