#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newparam(:tablespace_type) do
  include EasyType

  newvalues(:bigfile, :smallfile)

  data_type("Optional[Enum['bigfile', 'smallfile']]")

  desc <<-DESC
    Use this set the default type created tablespaces including SYSTEM and SYSAUX tablespaces.
  DESC

  on_apply do
    "SET DEFAULT #{value} TABLESPACE"
  end
end
