#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newproperty(:timezone, :parent => ::Puppet_X::EnterpriseModules::Oracle::ReadOnlyProperty) do
  include Puppet_X::EnterpriseModules::Oracle::Access
  include Puppet_X::EnterpriseModules::Oracle::Information
  include EasyType

  to_translate_to_resource do |raw_resource|
    database_properties(raw_resource['SID']).find { |e| e['PROPERTY_NAME'] == 'DBTIMEZONE' }['VALUE'] if raw_resource['STATE'] == 'running'
  end

  data_type('Optional[String[1]]')
  desc <<-DESC
    Set the time zone of the database.
  DESC
end
