# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:idle_time, :parent => Puppet::Parameter::OracleProfileProperty) do
  desc <<-DESC
    Allows you set the idle_time value in a profile.

    Allowed idle time before user is disconnected (minutes)

    idle_time <value | UNLIMITED | DEFAULT>

    Here is an example on how to use this:

        ora_profile { 'DEFAULT@sid':
          ...
          idle_time                 => 'UNLIMITED',
          ...
        }

  DESC
  data_type("Optional[Variant[Enum['DEFAULT','UNLIMITED'], Integer]]")
end
