# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:inactive_account_time, :parent => Puppet::Parameter::OracleProfileProperty) do
  desc <<-DESC
    Allows you set the inactive_account_time value in a profile.

    Setting determines the maximum number of days of inactivity (no logins at all) after which the account will be locked.

    inactive_account_time <value | UNLIMITED | DEFAULT>

    Here is an example on how to use this:

        ora_profile { 'DEFAULT@sid':
          ...
          inactive_account_time        => '120',
          ...
        }

  DESC
  data_type("Optional[Variant[Enum['DEFAULT','UNLIMITED'], Integer]]")
end
