# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:password_reuse_max, :parent => Puppet::Parameter::OracleProfileProperty) do
  desc <<-DESC
    Allows you set the password_reuse_max value in a profile.
    The number of times a password must be changed before it can be reused

    password_reuse_max <value | UNLIMITED | DEFAULT>

    Here is an example on how to use this:

        ora_profile { 'DEFAULT@sid':
          ...
          password_reuse_max        => 'UNLIMITED',
          ...
        }
  DESC
  data_type("Optional[Variant[Enum['DEFAULT','UNLIMITED'], Integer]]")
end
