# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:username) do
  include EasyType
  include EasyType::Validators::Name
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase

  defaultto ''

  desc <<-DESC
    The owner of the table.

    If none is specified, it will connect as the user specified in ora_setting.
  DESC

  data_type('String[1]')
end
