# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:pluggable, :boolean => true, :parent => Puppet::Property::Boolean) do
  include EasyType::YamlProperty

  desc <<-DESC
  Is the database we manage a pluggable database? If so set this value to true.

  When you set this property to `true`, you enable pluggable behaviour for this database. Here is
  an example on how to use this.

      ora_setting {container_database
        ...
        pluggable => true,
        ...
      }

  DESC
  defaultto :false
  newvalues(:true, :false)
  data_type('Boolean')
end
