# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:syspriv) do
  include EasyType::YamlProperty

  desc <<-DESC
    The privilege used to connect to the database or asm.

    You need to set this depending on the type of database.

        ora_setting { 'DB1':
          syspriv => 'sysdba',
        }


  DESC

  defaultto 'sysdba'
  newvalues(:normal, :sysdba, :sysasm, :sysoper, :sysbackup, :sysdg, :syskm)
  data_type("Enum['normal', 'sysdba', 'sysasm', 'sysoper', 'sysbackup', 'sysdg', 'syskm']")
end
