# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:synonym_name) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase

  desc <<-DESC
	The synonym name. This is the part of the title between the `.` and the `@`

		  ora_synonym { 'PUBLIC.SYNONYM_NAME@SID':
		  	...
		  }

  DESC

  isnamevar
  data_type('String[1]')
end
