# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:bigfile) do
  include EasyType

  desc <<-DESC
    Specify if you want a `bigfile` or a `smallfile` tablespace.
  DESC

  newvalues('yes', 'no')
  data_type("Optional[Enum['yes','no']]")

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('BIG').downcase
  end
end
