# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:tablespace_name) do
  include EasyType
  include EasyType::Validators::Name
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase

  desc <<-DESC
    The tablespace name.
  DESC

  data_type('String[1]')

  isnamevar

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('TABLESPACE_NAME')
  end
end
