# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/oracle/mungers'

newparam(:trigger_name) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase
  include EasyType::Validators::Name

  desc <<-DESC
    The name of the triggeryou want to manage. The trigger name  is the second part of the
    title.

        ora_trigger { 'owner.trigger_name@sid':
          ...
        }

  DESC

  data_type('String[1]')
  isnamevar
end
