# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# docs
module Puppet_X
  module EnterpriseModules
    module Oracle
      # rubocop:disable Style/Documentation
      class ReadOnlyProperty < Puppet::Property
        # rubocop:enable Style/Documentation
        def insync?(is)
          Puppet.warning "#{path} is a puppet read-only property; unable to change from #{is} to #{should}." if is.to_s != should.to_s
          true
        end
      end
    end
  end
end
