#
# ::clear_caches
#
# @summary This class contains the puppet code that implements the default facter cache invalidation rules.
# Whenever a certain set of Puppet classes or defined types is applied, it will clear the facter caches for those facts that are implemented.
#
#
# See the file "LICENSE" for the full license governing this code.
#
class ora_config::clear_caches () {
  fact_cache { 'ora_is_container_db':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_database<||> ~> Fact_cache['ora_is_container_db']

  fact_cache { 'ora_is_root_db':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_database<||> ~> Fact_cache['ora_is_root_db']

  fact_cache { 'ora_is_seed_db':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_database<||> ~> Fact_cache['ora_is_seed_db']

  fact_cache { 'ora_is_pluggable_db':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_database<||> ~> Fact_cache['ora_is_pluggable_db']

  fact_cache { 'ora_is_cluster':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_database<||> ~> Fact_cache['ora_is_cluster']

  fact_cache { 'ora_version':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_database<||> ~> Fact_cache['ora_version']

  fact_cache { 'ora_is_primary_db':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_database<||> ~> Fact_cache['ora_is_primary_db']

  fact_cache { 'ora_asm_running':
    ensure      => absent,
    refreshonly => true,
  }

  fact_cache { 'ora_asm_diskgroups':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_asm_diskgroup<||> ~> Fact_cache['ora_asm_diskgroups']

  fact_cache { 'ora_asm_volumes':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_asm_volume<||> ~> Fact_cache['ora_asm_volumes']
}
